#include <dht.h>
#include <LiquidCrystal.h>
#define DHT11_PIN 25
dht DHT;
LiquidCrystal lcd(7, 6, 5, 4, 3, 2);

int analogPin = A0;
int moisture;
int percentage;
int map_low = 697;
int map_high = 150;
int automatic = 1;

const int ventilation = 11;
const int waterpump = 28;
const int airfreshener = 22;
const int light = 42;


void setup() {
  pinMode(ventilation, OUTPUT);
//  digitalWrite(ventilation, LOW);

  pinMode(light, OUTPUT);
//  digitalWrite(light, LOW);

  pinMode(waterpump, OUTPUT);
//  digitalWrite(waterpump, LOW);

  pinMode(airfreshener, OUTPUT);
//  digitalWrite(airfreshener, LOW);

  Serial.begin(9600);
  lcd.begin(16, 2);

}

void loop() {

/***************************************************************************************(temperature & humidity)*****************************************************************************/
  int chk = DHT.read11(DHT11_PIN);

  if(automatic){
    
      if(DHT.temperature > 29.00)){
        digitalWrite(ventilation, HIGH);
      }

      if(DHT.humidity < 50){
        digitalWrite(airfreshener, HIGH);
      }
  
  }

/****************************************************************************************(soil moisture & waterpump)***************************************************************************/
 moisture = analogRead(analogPin);

 /* if(moisture>map_low){
    map_low=moisture;
  }
  if(moisture<map_high){
    map_high=moisture;
  }*/
  
//  Serial.print("Raw: ");
//  Serial.print(moisture);
//  Serial.print("");

  percentage = map(moisture, map_low, map_high, 0, 100);
  if(percentage>100){
    percentage=100;
}
  if(percentage<0){
    percentage=0;
  }


  lcd.setCursor(0,0); 
  lcd.print(DHT.temperature);
  lcd.print((char)178);
  lcd.print("C");

  lcd.setCursor(8,0); 
  lcd.print("  ");
  
  lcd.setCursor(10,0); 
  lcd.print(DHT.humidity);
  lcd.print("%");

  lcd.setCursor(0,1);
  lcd.print(percentage);
  lcd.print("%");

//  Serial.print("Soil moisture: ");
//  Serial.print(percentage);

if(automatic){

   if(percentage < 50) {
     digitalWrite(waterpump, LOW);
     delay(1500);
     digitalWrite(waterpump,HIGH);
   }
   
}

}
